# Initialise the array to hold the config variables
proc initctrdata {dev} {
    set arr device$dev
    global ${arr}
    global config${arr}

    # Create the data array of configuration variables
    foreach i [$dev configure] {
	set ${arr}([string trimleft [lindex $i 0] "-"]) [lindex $i 1]
    }
    settimebase ${arr}
    set config${arr}(value) 100

    if {[trace vinfo ${arr}] != {}} {
 	trace vdelete ${arr} w "tracedevice $dev"
    }
    trace variable ${arr} w "tracedevice $dev"
}

# Make the menubar widget for the ADC
proc makectrmenubar {w arr} {
    global ${arr}

    # Build the DAC menubar
    frame $w -borderwidth 2 -relief raised

    # The File menu
    set m $w.filemenu
    menubutton $m \
	    -menu "$m.m" \
	    -text {File}
    menu $m.m
    $m.m add command \
	    -command "destroy [winfo toplevel $w]" \
	    -label {Quit}
 
    # The Help Menu
    set m $w.helpmenu
    menubutton $m \
	    -menu "$m.m" \
	    -text {Help}
    menu $m.m
    $m.m add command \
	    -label {LabPC} \
	    -command "popuphelp labpc"
    $m.m add command \
	    -label {DAC} \
	    -command "popuphelp Counter"

    # Pack them all together
    pack append $w \
	    $w.filemenu {left frame center} \
	    $w.helpmenu {right frame center}
}

proc SetCounter {ctr} {
    set arr device${ctr}
    global ${arr}
    global config${arr}

    $ctr write [set config${arr}(value)]
}

proc makectrdisplay {w dev arr} {
    global ${arr}
    global config${arr}

    # Build the analogue display widget
    frame $w

    # Build the control panel
    set p $w.panel
    frame $p \
	    -relief raised \
	    -borderwidth 2

    # Counter set button
    button $p.write \
	    -text "Set Counter" \
	    -command "SetCounter $dev"
    bind $p.write <Any-ButtonPress-3> "popuphelp \"counter set\""

    # Number of Samples
    set config${arr}(value) 100
    labelentry $p.value "Counter Value" config${arr}(value)
    set config${arr}(value) [option get $p.value value Value]

    # Mode
    combo $p.mode ${arr} ${arr}(mode) \
	    "Mode" {terminal oneshot rate squarewave softstrobe hardstrobe }

    # Pack the buttons into the control panel
    pack append $p \
	    $p.write		{top pady 5} \
	    $p.value		{top pady 5} \
	    $p.mode		{top fillx pady 5} \

    # Pack the display widget
    pack append $w \
	    $w.panel {right frame center filly}
}

# procedure to show window
proc ctrwidget {w dac} {
    global device$dac
    set arr device$dac

    initctrdata $dac

    catch "destroy $w"

    # The encasing frame for the entire widget
    frame $w \
	    -class Counter

    # Build the widget menubar
    makectrmenubar $w.menubar $arr

    # Build the analogue display widget
    makectrdisplay $w.display $dac $arr

    pack append $w \
	    $w.menubar {top frame center fillx} \
	    $w.display {top fillx filly expand} \
}
